/*******************************************************************
 * Homebrew Vibratome: 
 * Current PINOUT: Arduino Nano

 * Sources:
 * https://www.best-microcontroller-projects.com/rotary-encoder.html
 * Button: https://create.arduino.cc/projecthub/SBR/working-with-an-led-and-a-push-button-71d8c1
 * Vibration: https://learn.adafruit.com/adafruit-drv2605-haptic-controller-breakout/arduino-code
 * Stepper: https://www.airspayce.com/mikem/arduino/AccelStepper/index.html
 * 
 * *****************************************************************
 */

//LIBRARIES
#include <Wire.h>
#include <MultiStepper.h>
#include <AccelStepper.h>

//ALL STEPPER PIN VARIABLES CHANGE TO MEET YOUR BOARD

#define D1 5  //screw stepper motor A1
#define D2 7  //screw stepper motor A2
#define E1 8  //screw stepper motor B1
#define E2 6  //screw stepper motor B2
              //ROTARY PINS

//Button Vars
#define BUTTON1 3   //State 1
#define BUTTON2 2   //State 2 

#define but1 13
#define but2 4
//Belt motors
#define belt1 12  //dc motor pin1
#define belt2 11  //dc motor pin2

//Saw motor
#define cycle1 10
#define cycle2 9






// pinout

AccelStepper screw(AccelStepper::FULL4WIRE, D1, D2, E1, E2);
//bool firstRun = false; //do not change...this is for the on/off/on button to determine if the motor has stepped since being switched to an on position
int dis1 = 100;
int dis2 = 0;      //distance travelled ****NEED TO TEST TO GET EXACT DISTANCE PER ROTATION.
int speed1 = 100;  //speed of rotation
// pinout



//Button Vars
int Forwardstate = 0;
int Backwardstate = 0;

int Upwardstate = 0;
int Downwardstate = 0;

//////////////////////////////////////////////////// Should be constant and only calls variables from above do not touch.
void setup() {
  //encoder
  pinMode(but1, INPUT);
  pinMode(but2, INPUT);
  //y axis
  pinMode(D1, OUTPUT);
  pinMode(D2, OUTPUT);
  pinMode(E1, OUTPUT);
  pinMode(E2, OUTPUT);
  //button
  pinMode(BUTTON1, INPUT);
  pinMode(BUTTON2, INPUT);
  //xaxis
  screw.setMaxSpeed(speed1);
  screw.setAcceleration(100);
  screw.setSpeed(speed1); 

  //Belt
  pinMode(belt1, OUTPUT);
  pinMode(belt2, OUTPUT);
  digitalWrite(belt1, LOW);
  digitalWrite(belt2, LOW);
  //Saw   
  pinMode(cycle1, OUTPUT);
  pinMode(cycle2, OUTPUT);
  digitalWrite(cycle1, LOW);
  digitalWrite(cycle2, LOW);

  //general
  screw.setAcceleration(400);
  Serial.begin(9600);
  Serial.print("This is where the fun begins...");
}



//======MAIN LOOP ADD ANY OTHER LOOPS AS SHOWN======
void loop() {
  yaxis();
  xaxis();
}


//======Controls yaxis (Stepper motors)======
void yaxis() {
  //While we originally intended to use a rotary encoder, due to unforseen complications, this code was rewritten to be used via buttons. 
  //Plenty of online tutorials exist for how to code a rotary encoder allowing users to make a more precise control mechanism. 
  Upwardstate = digitalRead(but1);
  Downwardstate = digitalRead(but2);
  screw.setSpeed(100);
//Bring the mount up 10 steps.
  if (Upwardstate == HIGH) {
    Serial.println("up");
    dis2 = (dis2 + 10);
    screw.move(dis2);
    screw.runToPosition();

//Bring the mount down 10 steps. 
  } else if (Downwardstate == HIGH) {
   Serial.println("down");
   dis2= (dis2 - 10);
   screw.move(dis2);
   screw.runToPosition();
  } else {
    //do nothing
  }}



// Controls blade and gantry plate
void xaxis() {

  Forwardstate = digitalRead(BUTTON1);
  Backwardstate = digitalRead(BUTTON2);
  screw.setSpeed(100);
//While moving forward, turn the blade on (cycle), and move the gantry plate forward.
  if (Forwardstate == HIGH) {
    Serial.println("forward");
    digitalWrite(cycle1, HIGH);
    digitalWrite(cycle2, LOW);
    digitalWrite(belt1, HIGH);
    digitalWrite(belt2, LOW);

//If moving the plate backwards, turn the blade off and move the plate in the other direction.
  } else if (Backwardstate == HIGH) {
    Serial.println("reverse");
    digitalWrite(belt2, HIGH);
    digitalWrite(belt1, LOW);
//Everything Off
  } else {
    digitalWrite(belt1,LOW);
    digitalWrite(belt2, LOW);
    digitalWrite(cycle1, LOW);
    digitalWrite(cycle2, LOW);

  }
}